--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____lib = require("lib.index")
local Events = ____lib.Events
local ____diff_2Dvalue = require("utils.diff-value")
local getNilPlaceholder = ____diff_2Dvalue.getNilPlaceholder
function ____exports.isBpNilPlaceholder(value)
    return type(value) == "table" and value.__nil ~= nil
end
local nilPlaceholder
Events.onInitOrLoad(function()
    nilPlaceholder = getNilPlaceholder()
end)
local blueprintNilPlaceholder = {__nil = true}
function ____exports.toBpStageDiffs(diffs)
    local ret = {}
    for stage, diff in pairs(diffs) do
        local bpDiff = {}
        for key, value in pairs(diff) do
            bpDiff[key] = value == nilPlaceholder and blueprintNilPlaceholder or value
        end
        ret[stage] = bpDiff
    end
    return ret
end
function ____exports.fromBpStageDiffs(diffs)
    local ret = {}
    for stage, diff in pairs(diffs) do
        local stageDiff = {}
        for key, value in pairs(diff) do
            local ____key_1 = key
            local ____isBpNilPlaceholder_result_0
            if ____exports.isBpNilPlaceholder(value) then
                ____isBpNilPlaceholder_result_0 = nilPlaceholder
            else
                ____isBpNilPlaceholder_result_0 = value
            end
            stageDiff[____key_1] = ____isBpNilPlaceholder_result_0
        end
        ret[tonumber(stage)] = stageDiff
    end
    return ret
end
return ____exports
