--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____lib = require("lib.index")
local isEmpty = ____lib.isEmpty
local ____blueprint_2Dstage_2Dinfo = require("copy-paste.blueprint-stage-info")
local toBpStageDiffs = ____blueprint_2Dstage_2Dinfo.toBpStageDiffs
function ____exports.createBlueprintWithStageInfo(player, stage, area)
    local ____global_players_player_index_0, ____tempBpInventory_1 = global.players[player.index], "tempBpInventory"
    if ____global_players_player_index_0[____tempBpInventory_1] == nil then
        ____global_players_player_index_0[____tempBpInventory_1] = game.create_inventory(1)
    end
    local inventory = global.players[player.index].tempBpInventory
    local stack = inventory[1]
    stack.clear()
    stack.set_stack("blueprint")
    local entityMapping = stack.create_blueprint({surface = stage.surface, force = player.force_index, area = area})
    if isEmpty(entityMapping) then
        stack.clear()
        return nil
    end
    local blueprintEntities = stack.get_blueprint_entities()
    local content = stage.project.content
    local stageNumber = stage.stageNumber
    for number, luaEntity in pairs(entityMapping) do
        do
            local projectEntity = content:findExact(luaEntity, luaEntity.position, stageNumber)
            if not projectEntity then
                goto __continue4
            end
            local info = {firstStage = projectEntity.firstStage, lastStage = projectEntity.lastStage}
            local diffs = projectEntity.stageDiffs
            if diffs then
                info.firstValue = projectEntity.firstValue
                info.stageDiffs = toBpStageDiffs(diffs)
            end
            blueprintEntities[number].tags = {bp100 = info}
        end
        ::__continue4::
    end
    stack.set_blueprint_entities(blueprintEntities)
    return stack
end
____exports._mockable = true
return ____exports
