local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__New = ____lualib.__TS__New
local ____exports = {}
local ____lib = require("lib.index")
local RegisterClass = ____lib.RegisterClass
local Map2DImpl = __TS__Class()
Map2DImpl.name = "Map2DImpl"
function Map2DImpl.prototype.____constructor(self)
end
function Map2DImpl.prototype.get(self, x, y)
    local byX = self[x]
    return byX and byX[y]
end
function Map2DImpl.prototype.add(self, x, y, value)
    local ____self_x_1 = self[x]
    if ____self_x_1 == nil then
        local ____temp_0 = {}
        self[x] = ____temp_0
        ____self_x_1 = ____temp_0
    end
    local byX = ____self_x_1
    local existing = byX[y]
    if existing == nil then
        byX[y] = value
    else
        value._next = existing
        byX[y] = value
    end
end
function Map2DImpl.prototype.delete(self, x, y, value)
    local byX = self[x]
    if byX == nil then
        return
    end
    local first = byX[y]
    if first == nil then
        return
    end
    local _next = first._next
    if first == value then
        if _next ~= nil then
            byX[y] = _next
            first._next = nil
            return
        end
        byX[y] = nil
        if (next(byX)) == nil then
            self[x] = nil
        end
        return
    end
    local prev = first
    while _next ~= nil do
        if _next == value then
            prev._next = _next._next
            value._next = nil
            return
        end
        prev = _next
        _next = _next._next
    end
end
Map2DImpl = __TS__DecorateLegacy(
    {RegisterClass("Map2D")},
    Map2DImpl
)
function ____exports.newMap2D()
    return __TS__New(Map2DImpl)
end
local function isArray(value)
    return value.firstStage == nil
end
function ____exports._migrateMap2DToLinkedList(map)
    for ____, byX in pairs(map) do
        for y, value in pairs(byX) do
            if isArray(value) then
                local first = value[1]
                local prev = first
                do
                    local i = 1
                    while i < #value do
                        local next = value[i + 1]
                        prev._next = next
                        prev = next
                        i = i + 1
                    end
                end
                byX[y] = first
            else
                value._next = nil
                byX[y] = value
            end
        end
    end
end
return ____exports
