--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____lib = require("lib.index")
local Events = ____lib.Events
Events.on_init(function()
    global.entityByUnitNumber = {}
end)
--- Currently only used for rolling stock (train) entities.
function ____exports.registerEntity(luaEntity, projectEntity)
    if not luaEntity.valid then
        return false
    end
    local unitNumber = luaEntity.unit_number
    if not unitNumber then
        return false
    end
    local entry = global.entityByUnitNumber[unitNumber]
    if entry then
        return true
    end
    global.entityByUnitNumber[unitNumber] = projectEntity
    script.register_on_entity_destroyed(luaEntity)
    return true
end
function ____exports.getRegisteredProjectEntity(entity)
    if not entity.valid then
        return nil
    end
    local unitNumber = entity.unit_number
    return unitNumber and global.entityByUnitNumber[unitNumber]
end
Events.on_entity_destroyed(function(e)
    local eNumber = e.unit_number
    if eNumber then
        global.entityByUnitNumber[eNumber] = nil
    end
end)
return ____exports
