--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____Events = require("lib.Events")
local Events = ____Events.Events
local scriptEventIds = ____Events.scriptEventIds
local ____protected_2Daction = require("lib.protected-action")
local protectedAction = ____protected_2Daction.protectedAction
local function wrapFunction(func)
    return function(e) return protectedAction(func, e) end
end
local ProtectedEvents = {
    on = function(event, func)
        Events.on(
            event,
            wrapFunction(func)
        )
    end,
    onAll = function(handlers)
        for key, func in pairs(handlers) do
            if not (key == "on_load" or key == "on_init" or key == "on_configuration_changed") then
                handlers[key] = wrapFunction(func)
            end
        end
        Events.onAll(handlers)
    end,
    onInitOrLoad = function(f)
        Events.onInitOrLoad(f)
    end
}
setmetatable(
    ProtectedEvents,
    {__index = function(self, key)
        if scriptEventIds[key] ~= nil then
            return Events[key]
        end
        if defines.events[key] ~= nil then
            return function(handler)
                Events[key](wrapFunction(handler))
            end
        end
    end}
)
____exports.ProtectedEvents = ProtectedEvents
return ____exports
