--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____ProtectedEvents = require("lib.ProtectedEvents")
local ProtectedEvents = ____ProtectedEvents.ProtectedEvents
local globalHandlers = {on_player_selected_area = {}, on_player_alt_selected_area = {}, on_player_reverse_selected_area = {}, on_player_alt_reverse_selected_area = {}}
function ____exports.addSelectionToolHandlers(prototype, handlers)
    if handlers.onSelected then
        globalHandlers.on_player_selected_area[prototype] = handlers.onSelected
    end
    if handlers.onAltSelected then
        globalHandlers.on_player_alt_selected_area[prototype] = handlers.onAltSelected
    end
    if handlers.onReverseSelected then
        globalHandlers.on_player_reverse_selected_area[prototype] = handlers.onReverseSelected
    end
    if handlers.onAltReverseSelected then
        globalHandlers.on_player_alt_reverse_selected_area[prototype] = handlers.onAltReverseSelected
    end
end
for eventName, handlers in pairs(globalHandlers) do
    ProtectedEvents[eventName](function(event)
        local handler = handlers[event.item]
        if handler ~= nil then
            handler(event)
        end
    end)
end
return ____exports
