--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____entity_2Dprototype_2Dinfo = require("entity.entity-prototype-info")
local getEntityPrototypeInfo = ____entity_2Dprototype_2Dinfo.getEntityPrototypeInfo
local ____ProjectContent = require("entity.ProjectContent")
local _migrateProjectContent_0_18_0 = ____ProjectContent._migrateProjectContent_0_18_0
local _migrateWireConnections = ____ProjectContent._migrateWireConnections
local ____ProjectEntity = require("entity.ProjectEntity")
local _migrateEntity_0_17_0 = ____ProjectEntity._migrateEntity_0_17_0
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
Migrations.to(
    "0.14.0",
    function()
        for ____, project in pairs(global.projects) do
            for entity in pairs(project.content:iterateAllEntities()) do
                entity.oldStage = nil
            end
        end
    end
)
Migrations.to(
    "0.14.3",
    function()
        for ____, project in pairs(global.projects) do
            for entity in pairs(project.content:iterateAllEntities()) do
                if entity:isRollingStock() then
                    project.entityUpdates.updateWorldEntities(entity, 1)
                end
            end
        end
    end
)
Migrations.priority(
    7,
    "0.22.0",
    function()
        for ____, project in pairs(global.projects) do
            for entity in pairs(project.content:iterateAllEntities()) do
                if entity.direction == nil then
                    entity.direction = 0
                end
            end
        end
    end
)
Migrations.priority(
    7,
    "0.28.0",
    function()
        for ____, project in pairs(global.projects) do
            _migrateWireConnections(project.content)
        end
    end
)
Migrations.early(
    "0.17.0",
    function()
        for ____, project in pairs(global.projects) do
            for entity in pairs(project.content:iterateAllEntities()) do
                _migrateEntity_0_17_0(entity)
            end
        end
    end
)
Migrations.early(
    "0.18.0",
    function()
        for ____, project in pairs(global.projects) do
            _migrateProjectContent_0_18_0(project.content)
        end
    end
)
Migrations.to(
    "0.18.0",
    function()
        for ____, project in pairs(global.projects) do
            for entity in pairs(project.content:iterateAllEntities()) do
                if entity:isRollingStock() then
                    entity:setLastStageUnchecked(entity.firstStage)
                    project.entityUpdates.updateWorldEntitiesOnLastStageChanged(entity, nil)
                end
            end
        end
    end
)
Migrations.to(
    "0.20.0",
    function()
        local nameToType = getEntityPrototypeInfo().nameToType
        for ____, project in pairs(global.projects) do
            for entity in pairs(project.content:iterateAllEntities()) do
                if nameToType[entity.firstValue.name] == "power-switch" then
                    project.updates.updateWiresFromWorld(
                        entity,
                        project:lastStageFor(entity)
                    )
                end
            end
        end
    end
)
Migrations.to(
    "0.23.1",
    function()
        for ____, project in pairs(global.projects) do
            for entity in pairs(project.content:iterateAllEntities()) do
                if entity:hasStageDiff() or entity.lastStage ~= nil then
                    project.entityUpdates.updateAllHighlights(entity)
                end
            end
        end
    end
)
return ____exports
