local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local ____exports = {}
local ____lib = require("lib.index")
local property = ____lib.property
local ____DiffedProperty = require("utils.DiffedProperty")
local DiffedProperty = ____DiffedProperty.DiffedProperty
function ____exports.getCurrentValues(propertiesTable)
    local result = {}
    for key, value in pairs(propertiesTable) do
        result[key] = value:get()
    end
    return result
end
function ____exports.createPropertiesTable(keys, values)
    local result = {}
    for ____, key in ipairs(keys) do
        result[key] = property(values[key])
    end
    return result
end
function ____exports.createEmptyPropertyOverrideTable(keys)
    local result = {}
    for ____, key in ipairs(keys) do
        result[key] = property(nil)
    end
    return result
end
function ____exports.createdDiffedPropertyTableView(defaultValues, overrideValues)
    local result = {}
    for key, defaultValue in pairs(defaultValues) do
        result[key] = __TS__New(DiffedProperty, overrideValues[key], defaultValue)
    end
    return result
end
return ____exports
