--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
do
    pcall(require, "test.module-mock")
end
local ____exports = {}
local ____lib = require("lib.index")
local Events = ____lib.Events
local ____migration = require("lib.migration")
local formatVersion = ____migration.formatVersion
local Migrations = ____migration.Migrations
require("project.index")
require("ui.index")
pcall(require, "test.test-init")
Events.on_init(function()
    local force = game.forces.player
    force.research_all_technologies()
    force.enable_all_recipes()
end)
Events.on_configuration_changed(function(data)
    local thisChange = data.mod_changes[script.mod_name]
    if not thisChange then
        return
    end
    local oldVersion = thisChange.old_version
    if not oldVersion then
        return
    end
    if formatVersion(oldVersion) < formatVersion("0.13.1") then
        error("Staged blueprint planning: migrating from a version earlier than 0.13.1 is no longer supported after v0.16.0 " .. "Try installing version 0.15.x first (by downloading directly from the mod portal), loading/saving the game, THEN install the latest version.")
    end
    Migrations.doMigrations(oldVersion)
end)
return ____exports
