--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____lib = require("lib.index")
local deepCompare = ____lib.deepCompare
local Events = ____lib.Events
local shallowCopy = ____lib.shallowCopy
local ____diff_2Dvalue = require("utils.diff-value")
local getNilPlaceholder = ____diff_2Dvalue.getNilPlaceholder
local ignoredProps = {position = true, direction = true}
local nilPlaceholder
Events.onInitOrLoad(function()
    nilPlaceholder = getNilPlaceholder()
end)
function ____exports.getEntityDiff(below, above)
    local changes = nil
    for key, value in pairs(above) do
        if not (ignoredProps[key] ~= nil) and not deepCompare(value, below[key]) then
            if changes == nil then
                changes = {}
            end
            changes[key] = value
        end
    end
    for key in pairs(below) do
        if not (ignoredProps[key] ~= nil) and above[key] == nil then
            if changes == nil then
                changes = {}
            end
            changes[key] = nilPlaceholder
        end
    end
    return changes
end
function ____exports.applyDiffToEntity(entity, diff)
    for key, value in pairs(diff) do
        if value == nilPlaceholder then
            entity[key] = nil
        else
            entity[key] = value
        end
    end
end
function ____exports.getDiffDiff(previousValue, oldDiff, newDiff)
    if oldDiff == nil then
        return newDiff and shallowCopy(newDiff)
    end
    local result = nil
    if newDiff == nil then
        for key in pairs(oldDiff) do
            if result == nil then
                result = {}
            end
            local value = previousValue[key]
            result[key] = value ~= nil and value or nilPlaceholder
        end
    else
        for key, value in pairs(newDiff) do
            if not deepCompare(value, oldDiff[key]) then
                if result == nil then
                    result = {}
                end
                result[key] = value
            end
        end
        for key in pairs(oldDiff) do
            if newDiff[key] == nil then
                if result == nil then
                    result = {}
                end
                local value = previousValue[key]
                result[key] = value ~= nil and value or nilPlaceholder
            end
        end
    end
    return result
end
return ____exports
