--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
--- Returns just a metatable for {@link LazyLoadClass}.
function ____exports.lazyLoadMt(load)
    return {__index = function(self, key)
        if rawget(self, "_loaded") then
            return nil
        end
        local value = load(self)
        for k, v in pairs(value) do
            if type(v) ~= "function" then
                error("LazyLoad only supports functions")
            end
            self[k] = v
        end
        self._loaded = function()
        end
        return value[key]
    end}
end
--- Creates a class that will lazily load its methods when they are first called.
-- This allows you to use a closure-based class, while being able to be stored/loaded in global.
function ____exports.LazyLoadClass(registeredName, load)
    local mt = ____exports.lazyLoadMt(load)
    script.register_metatable(registeredName, mt)
    return function(value) return setmetatable(value, mt) end
end
return ____exports
