local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__New = ____lualib.__TS__New
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local ____exports = {}
local EventSubscription
local _____util = require("lib._util")
local shallowCopy = _____util.shallowCopy
local ____references = require("lib.references")
local RegisterClass = ____references.RegisterClass
local ____Subscription = require("lib.event.Subscription")
local Subscription = ____Subscription.Subscription
____exports.Event = __TS__Class()
local Event = ____exports.Event
Event.name = "Event"
function Event.prototype.____constructor(self)
end
function Event.prototype._subscribeIndependently(self, observer)
    local thisAsMap = self
    local subscription = __TS__New(EventSubscription, thisAsMap)
    thisAsMap[subscription] = observer
    return subscription
end
function Event.prototype.subscribe(self, context, observer)
    local subscription = self:_subscribeIndependently(observer)
    context:add(subscription)
    return subscription
end
function Event.prototype.raise(self, ...)
    local thisAsMap = self
    for subscription, observer in pairs(shallowCopy(thisAsMap)) do
        if thisAsMap[subscription] ~= nil then
            observer:invoke(...)
        end
    end
end
function Event.prototype.closeAll(self)
    local thisAsMap = self
    for subscription in pairs(shallowCopy(thisAsMap)) do
        subscription:close()
        thisAsMap[subscription] = nil
    end
end
Event = __TS__DecorateLegacy(
    {RegisterClass("ObserverList")},
    Event
)
____exports.Event = Event
EventSubscription = __TS__Class()
EventSubscription.name = "EventSubscription"
__TS__ClassExtends(EventSubscription, Subscription)
function EventSubscription.prototype.____constructor(self, observers)
    Subscription.prototype.____constructor(self)
    self.observers = observers
end
function EventSubscription.prototype.close(self)
    self.observers[self] = nil
    Subscription.prototype.close(self)
end
EventSubscription = __TS__DecorateLegacy(
    {RegisterClass("ObserverSubscription")},
    EventSubscription
)
____exports.SimpleEvent = ____exports.Event
return ____exports
