--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____index = require("lib.index")
local funcRef = ____index.funcRef
local registerFunctions = ____index.registerFunctions
local ____index = require("lib.factoriojsx.index")
local destroy = ____index.destroy
local FactorioJsx = ____index.FactorioJsx
local ____buttons = require("lib.factoriojsx.components.buttons")
local CloseButton = ____buttons.CloseButton
local ____misc = require("lib.factoriojsx.components.misc")
local HorizontalPusher = ____misc.HorizontalPusher
function ____exports.TitleBar(props)
    return FactorioJsx.createElement(
        "flow",
        {
            direction = "horizontal",
            styleMod = {horizontal_spacing = 8, height = 28},
            onCreate = function(____, element)
                local parent = element.parent
                if parent.type == "frame" and parent.parent == element.gui.screen then
                    element.drag_target = parent
                end
            end
        },
        props.children
    )
end
function ____exports.DraggableSpace()
    return FactorioJsx.createElement("empty-widget", {ignored_by_interaction = true, style = "draggable_space", styleMod = {horizontally_stretchable = true, height = 24}})
end
function ____exports.closeParentParent(e)
    local parent = e.element.parent.parent
    if parent.type == "frame" then
        destroy(parent)
    end
end
function ____exports.closeSelf(e)
    destroy(e.element)
end
registerFunctions("gui:TitleBar", {closeParentParent = ____exports.closeParentParent, closeSelf = ____exports.closeSelf})
function ____exports.SimpleTitleBar(props)
    local ____FactorioJsx_createElement_3 = FactorioJsx.createElement
    local ____exports_TitleBar_1 = ____exports.TitleBar
    local ____FactorioJsx_createElement_result_2 = FactorioJsx.createElement("label", {caption = props.title, style = "frame_title", ignored_by_interaction = true})
    local ____temp_0
    if props.useDraggableSpace ~= false then
        ____temp_0 = FactorioJsx.createElement(____exports.DraggableSpace, nil)
    else
        ____temp_0 = FactorioJsx.createElement(HorizontalPusher, nil)
    end
    return ____FactorioJsx_createElement_3(
        ____exports_TitleBar_1,
        nil,
        ____FactorioJsx_createElement_result_2,
        ____temp_0,
        FactorioJsx.createElement(
            CloseButton,
            {on_gui_click = props.onClose or funcRef(____exports.closeParentParent)}
        )
    )
end
return ____exports
