--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____Events = require("lib.Events")
local Events = ____Events.Events
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
--- Called when player is initialized (both during on_init and on_player_created).
function ____exports.onPlayerInit(action)
    Events.onAll({
        on_init = function()
            for ____, player in pairs(game.players) do
                action(player.index)
            end
        end,
        on_player_created = function(e)
            action(e.player_index)
        end
    })
end
function ____exports.onPlayerInitSince(version, action)
    local function initForAllPlayers()
        for ____, player in pairs(game.players) do
            action(player.index)
        end
    end
    Migrations.early(version, initForAllPlayers)
    Events.on_init(initForAllPlayers)
    Events.on_player_created(function(e)
        action(e.player_index)
    end)
end
Events.on_init(function()
    global.players = {}
end)
____exports.onPlayerInit(function(index)
    if global.players == nil then
        global.players = {}
    end
    global.players[index] = {}
end)
local playerRemovedHandlers = {}
function ____exports.onPlayerRemoved(action)
    playerRemovedHandlers[#playerRemovedHandlers + 1] = action
end
Events.on_player_removed(function(e)
    local index = e.player_index
    for ____, handler in ipairs(playerRemovedHandlers) do
        handler(index)
    end
    if global.players ~= nil then
        global.players[index] = nil
    end
end)
return ____exports
