--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local getErrorWithStacktrace, reportUnexpectedError
function getErrorWithStacktrace(____error)
    local errorToString = tostring(____error)
    return {
        errorToString,
        debug.traceback(errorToString, 3)
    }
end
function reportUnexpectedError(____error)
    local message, traceback = table.unpack(____error)
    log({"", "Protected action: unexpected error occurred:\n", traceback})
    game.print({"bp100.interaction.unexpected-error", message})
end
function ____exports.protectedAction(action, ...)
    local success, result = xpcall(action, getErrorWithStacktrace, ...)
    if success then
        return result
    end
    reportUnexpectedError(result)
end
return ____exports
