--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____lib = require("lib.index")
local onPlayerInit = ____lib.onPlayerInit
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
local ____UserProject = require("project.UserProject")
local ProjectEvents = ____UserProject.ProjectEvents
onPlayerInit(function(index)
    global.players[index].projectPlayerData = {}
end)
Migrations.early(
    "0.23.0",
    function()
        for ____, player in pairs(game.players) do
            do
                local playerData = global.players[player.index]
                if not playerData then
                    goto __continue4
                end
                playerData.projectPlayerData = playerData.assemblyPlayerData
                playerData.assemblyPlayerData = nil
            end
            ::__continue4::
        end
    end
)
ProjectEvents:addListener(function(e)
    if e.type == "project-deleted" then
        for ____, player in pairs(game.players) do
            global.players[player.index].projectPlayerData[e.project.id] = nil
        end
    end
end)
function ____exports.getProjectPlayerData(player, project)
    if not project.valid then
        return nil
    end
    local map = global.players[player].projectPlayerData
    local id = project.id
    if not (map[id] ~= nil) then
        map[id] = {}
    end
    return map[id]
end
return ____exports
