local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local ____exports = {}
local ____lib = require("lib.index")
local ibind = ____lib.ibind
local property = ____lib.property
local Props = ____lib.Props
local RegisterClass = ____lib.RegisterClass
local ____factoriojsx = require("lib.factoriojsx.index")
local Component = ____factoriojsx.Component
local FactorioJsx = ____factoriojsx.FactorioJsx
local ____components = require("lib.factoriojsx.components.index")
local Fn = ____components.Fn
local RenameButton = ____components.RenameButton
____exports.ItemRename = __TS__Class()
local ItemRename = ____exports.ItemRename
ItemRename.name = "ItemRename"
__TS__ClassExtends(ItemRename, Component)
function ItemRename.prototype.____constructor(self, ...)
    Component.prototype.____constructor(self, ...)
    self.isRenaming = property(false)
end
function ItemRename.prototype.render(self, props)
    self.item = props
    return FactorioJsx.createElement(
        "flow",
        {direction = "horizontal", styleMod = {vertical_align = "center", horizontal_spacing = 5}},
        FactorioJsx.createElement(
            Fn,
            {
                uses = "flow",
                from = self.isRenaming,
                map = ibind(self, "nameDisplay")
            }
        ),
        FactorioJsx.createElement(
            RenameButton,
            {
                tooltip = props.renameTooltip,
                on_gui_click = Props.toggleFn(self.isRenaming)
            }
        )
    )
end
function ItemRename.prototype.nameDisplay(self, isRenaming)
    return isRenaming and FactorioJsx.createElement(
        "textfield",
        {
            text = self.item.name,
            clear_and_focus_on_right_click = true,
            lose_focus_on_confirm = true,
            on_gui_confirmed = Props.setValueFn(self.isRenaming, false),
            styleMod = {maximal_width = self.item.maximalWidth or 200},
            onCreate = function(____, e) return e.focus() end
        }
    ) or FactorioJsx.createElement("label", {style = "subheader_caption_label", caption = self.item.displayName, styleMod = {maximal_width = self.item.maximalWidth or 200}, ignored_by_interaction = true})
end
ItemRename = __TS__DecorateLegacy(
    {RegisterClass("gui:ItemRename")},
    ItemRename
)
____exports.ItemRename = ItemRename
return ____exports
