--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____lib = require("lib.index")
local Events = ____lib.Events
local onPlayerInit = ____lib.onPlayerInit
local editorGuiWidth = 474
local function updatePlayer(player)
    local isEditor = player.controller_type == defines.controllers.editor
    if isEditor then
        player.gui.top.style.left_margin = editorGuiWidth
        player.gui.left.style.left_margin = editorGuiWidth
    else
        player.gui.top.style.left_margin = 0
        player.gui.left.style.left_margin = 0
    end
end
if script.active_mods.EditorExtensions == nil then
    local function update(index)
        local player = game.get_player(index)
        updatePlayer(player)
    end
    Events.on_player_toggled_map_editor(function(e) return update(e.player_index) end)
    onPlayerInit(update)
end
Events.on_init(function()
    if script.active_mods.EditorExtensions == nil then
        for ____, player in pairs(game.players) do
            updatePlayer(player)
        end
    end
end)
return ____exports
